"""codecs

Revision ID: 272c02eb32f5
Revises: 4f4c3570d927
Create Date: 2018-08-31 15:41:30.616727

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl



# revision identifiers, used by Alembic.
revision = '272c02eb32f5'
down_revision = '4f4c3570d927'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
    connection = op.get_bind()
    connection.execute("delete from  resource_codecs_ref")
    connection.execute("delete from  codecs")
    connection.execute("insert into codecs(id,name,detail) values(1,'AMR(8000)/dynamic','AMR(8000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(2,'CN(8000)','CN(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(3,'DV14(11025)','DV14(11025)')")
    connection.execute("insert into codecs(id,name,detail) values(4,'DV14(22050)','DV14(22050)')")
    connection.execute(
        "insert into codecs(id,name,detail) values(5,'G7221(16000 or 32000)/dynamic','G7221(16000 or 32000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(6,'G7221C(32000)/dynamic','G7221C(32000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(7,'G722(8000)','G722(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(8,'G723(8000)','G723(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(9,'G726-16(8000)/dynamic','G726-16(8000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(10,'G726-24(8000)/dynamic','G726-24(8000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(11,'G726-32(8000)/dynamic','G726-32(8000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(12,'G726-40(8000)/dynamic','G726-40(8000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(13,'G728(8000)','G728(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(14,'G729(8000)','G729(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(15,'G729a','G729a')")
    connection.execute("insert into codecs(id,name,detail) values(16,'G729b','G729b')")
    connection.execute("insert into codecs(id,name,detail) values(17,'GSM(8000)','GSM(8000)')")
    connection.execute("insert into codecs(id,name,detail) values(18,'iLBC/dynamic','iLBC/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(19,'PCMA(G711.u 8000)','PCMA(G711.u 8000)')")
    connection.execute("insert into codecs(id,name,detail) values(20,'PCMU(G711.a 8000)','PCMU(G711.a 8000)')")
    connection.execute(
        "insert into codecs(id,name,detail) values(21,'Speex(8000, 16000 or 32000)/dynamic','Speex(8000, 16000 or 32000)/dynamic')")
    connection.execute("insert into codecs(id,name,detail) values(22,'telephone-event/dynamic','telephone-event/dynamic')")


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger class4_trig_record_{table} on {table};
drop table {table}_record;
DROP FUNCTION class4_trigfun_record_{table}();
DROP SEQUENCE {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))